/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
export * as app from './app';
export * as cdn from './cdn';
export * as certificate from './certificate';
export * as containerRegistry from './container-registry';
export * as containerRegistryDockerCredentials from './container-registry-docker-credentials';
export * as customImage from './custom-image';
export * as databaseCluster from './database-cluster';
export * as databaseConnectionPool from './database-connection-pool';
export * as databaseDb from './database-db';
export * as databaseFirewall from './database-firewall';
export * as databaseKafkaConfig from './database-kafka-config';
export * as databaseKafkaTopic from './database-kafka-topic';
export * as databaseMongodbConfig from './database-mongodb-config';
export * as databaseMysqlConfig from './database-mysql-config';
export * as databaseOpensearchConfig from './database-opensearch-config';
export * as databasePostgresqlConfig from './database-postgresql-config';
export * as databaseRedisConfig from './database-redis-config';
export * as databaseReplica from './database-replica';
export * as databaseUser from './database-user';
export * as domain from './domain';
export * as droplet from './droplet';
export * as dropletAutoscale from './droplet-autoscale';
export * as dropletSnapshot from './droplet-snapshot';
export * as firewall from './firewall';
export * as floatingIp from './floating-ip';
export * as floatingIpAssignment from './floating-ip-assignment';
export * as kubernetesCluster from './kubernetes-cluster';
export * as kubernetesNodePool from './kubernetes-node-pool';
export * as loadbalancer from './loadbalancer';
export * as monitorAlert from './monitor-alert';
export * as partnerAttachment from './partner-attachment';
export * as project from './project';
export * as projectResources from './project-resources';
export * as record from './record';
export * as reservedIp from './reserved-ip';
export * as reservedIpAssignment from './reserved-ip-assignment';
export * as reservedIpv6 from './reserved-ipv6';
export * as reservedIpv6Assignment from './reserved-ipv6-assignment';
export * as spacesBucket from './spaces-bucket';
export * as spacesBucketCorsConfiguration from './spaces-bucket-cors-configuration';
export * as spacesBucketObject from './spaces-bucket-object';
export * as spacesBucketPolicy from './spaces-bucket-policy';
export * as spacesKey from './spaces-key';
export * as sshKey from './ssh-key';
export * as tag from './tag';
export * as uptimeAlert from './uptime-alert';
export * as uptimeCheck from './uptime-check';
export * as volume from './volume';
export * as volumeAttachment from './volume-attachment';
export * as volumeSnapshot from './volume-snapshot';
export * as vpc from './vpc';
export * as vpcPeering from './vpc-peering';
export * as dataDigitaloceanAccount from './data-digitalocean-account';
export * as dataDigitaloceanApp from './data-digitalocean-app';
export * as dataDigitaloceanCertificate from './data-digitalocean-certificate';
export * as dataDigitaloceanContainerRegistry from './data-digitalocean-container-registry';
export * as dataDigitaloceanDatabaseCa from './data-digitalocean-database-ca';
export * as dataDigitaloceanDatabaseCluster from './data-digitalocean-database-cluster';
export * as dataDigitaloceanDatabaseConnectionPool from './data-digitalocean-database-connection-pool';
export * as dataDigitaloceanDatabaseReplica from './data-digitalocean-database-replica';
export * as dataDigitaloceanDatabaseUser from './data-digitalocean-database-user';
export * as dataDigitaloceanDomain from './data-digitalocean-domain';
export * as dataDigitaloceanDomains from './data-digitalocean-domains';
export * as dataDigitaloceanDroplet from './data-digitalocean-droplet';
export * as dataDigitaloceanDropletAutoscale from './data-digitalocean-droplet-autoscale';
export * as dataDigitaloceanDropletSnapshot from './data-digitalocean-droplet-snapshot';
export * as dataDigitaloceanDroplets from './data-digitalocean-droplets';
export * as dataDigitaloceanFirewall from './data-digitalocean-firewall';
export * as dataDigitaloceanFloatingIp from './data-digitalocean-floating-ip';
export * as dataDigitaloceanImage from './data-digitalocean-image';
export * as dataDigitaloceanImages from './data-digitalocean-images';
export * as dataDigitaloceanKubernetesCluster from './data-digitalocean-kubernetes-cluster';
export * as dataDigitaloceanKubernetesVersions from './data-digitalocean-kubernetes-versions';
export * as dataDigitaloceanLoadbalancer from './data-digitalocean-loadbalancer';
export * as dataDigitaloceanPartnerAttachment from './data-digitalocean-partner-attachment';
export * as dataDigitaloceanProject from './data-digitalocean-project';
export * as dataDigitaloceanProjects from './data-digitalocean-projects';
export * as dataDigitaloceanRecord from './data-digitalocean-record';
export * as dataDigitaloceanRecords from './data-digitalocean-records';
export * as dataDigitaloceanRegion from './data-digitalocean-region';
export * as dataDigitaloceanRegions from './data-digitalocean-regions';
export * as dataDigitaloceanReservedIp from './data-digitalocean-reserved-ip';
export * as dataDigitaloceanReservedIpv6 from './data-digitalocean-reserved-ipv6';
export * as dataDigitaloceanSizes from './data-digitalocean-sizes';
export * as dataDigitaloceanSpacesBucket from './data-digitalocean-spaces-bucket';
export * as dataDigitaloceanSpacesBucketObject from './data-digitalocean-spaces-bucket-object';
export * as dataDigitaloceanSpacesBucketObjects from './data-digitalocean-spaces-bucket-objects';
export * as dataDigitaloceanSpacesBuckets from './data-digitalocean-spaces-buckets';
export * as dataDigitaloceanSpacesKey from './data-digitalocean-spaces-key';
export * as dataDigitaloceanSshKey from './data-digitalocean-ssh-key';
export * as dataDigitaloceanSshKeys from './data-digitalocean-ssh-keys';
export * as dataDigitaloceanTag from './data-digitalocean-tag';
export * as dataDigitaloceanTags from './data-digitalocean-tags';
export * as dataDigitaloceanVolume from './data-digitalocean-volume';
export * as dataDigitaloceanVolumeSnapshot from './data-digitalocean-volume-snapshot';
export * as dataDigitaloceanVpc from './data-digitalocean-vpc';
export * as dataDigitaloceanVpcPeering from './data-digitalocean-vpc-peering';
export * as provider from './provider';
